{{ V2.5 upgrade programing

}}
VAR
    long    level                  '' Variable that contains the value of the dimmer level (0 - 255)
    long  wavcog                     ' start player in new cog
    
    long  volume                   ' volume of wav player
    long Stack[20]                 '' Stack space

OBJ
    
    Simulator   :"Clock_Simulator" '' Simulates a 120-Hz pulse from the zero-crossing H11AA1 Opto-Isolator (Short High Pulse)
        rc      : "RCTime3"     
    term        : "fullduplexserial"

CON
  _CLKMODE      =   XTAL1 + PLL16X                         
  _XINFREQ      =   5_000_000

  CrossDetect   =   29  '' Input pin number, Active HIGH from H11AA1
  Output        =   27  '' Output pin number, Active HIGH to MOC3010M to turn on Opto-Diac            

  LED_MSB = 27
  LED_LSB = 20

  COL_1   = 18
  COL_0   = 19

  RX1     = 31
  TX1     = 30
  SDA     = 29
  SCL     = 28

CON

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control
PUB wakeup | t, idx, tmp, Delay, rtime, V

  term.start(31, 30, %0000, 115200)
  

  term.tx(CLS)
  term.str(string("By your command:", CR))        

        dira[19..27]~~
        outa[19]~~

        ' DEMO Code to show how it works.
        
        Delay:=0              '' how long to delay in this demo program.

        Simulator.go(CrossDetect)   '' load the zero-crossing simulator that triggers 120 times a second.

  rc.RCTIME_forever(4, 500, 1, @rtime)          ' start loading sweep speed rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)

   term.str(string("rtime="))
  term.dec(rtime)
  term.str(string("     ",CR))
  

  
' Load the Dimmer PASM code.
level:=0                            '' Set the initial brightness level to off = 0.       
load(@level)                        '' Load the actual PASM Dimmer code. Tell it where the brightness variable lives.

        'repeat
            repeat tmp from 0 to 100             '255          '' sweep from off to on then on to off.
                level:=tmp
                waitcnt(clkfreq/20 + cnt)
                
level:=0                
                 
           ' repeat tmp from 255 to 0
            '    level:=tmp                                 
             '   waitcnt(clkfreq/Delay+cnt)

             
    volume := 0                      'set volume       

  wavcog := cognew(playsound(10, @Cylon, 0), @stack) + 1

            repeat V from 0 to 64
                   'waitcnt(clkfreq / (rtime / 1000)+ cnt)   
                  volume := ++volume <# 32        '32

                  
                          
      'this sets up the LED strip for the next subroutine
                       
          outa[26]~~
          waitcnt(clkfreq / (rtime / 2142)+ cnt)
          outa[26]~
          outa[25]~~
          waitcnt(clkfreq / (rtime / 2142)+ cnt)  
          outa[25]~
          outa[24]~~ 
          waitcnt(clkfreq / (rtime / 2142)+ cnt)
          outa[24]~
          outa[23]~~
          waitcnt(clkfreq / (rtime / 1714)+ cnt)
          outa[23]~
          outa[22]~~
          waitcnt(clkfreq / (rtime / 1714)+ cnt) 
          outa[22]~
          outa[21]~~
          waitcnt(clkfreq / (rtime / 1714)+ cnt) 
          outa[21]~
          outa[20]~~
          waitcnt(clkfreq / (rtime / 1500)+ cnt) 

  repeat
      if ina[0]==0
        death 
    repeat idx from 1 to 16        ' to
      out32(idx)
          term.tx(CLS)
          term.str(string("idx= to"))
          term.dec(idx)
          term.str(string("     ",CR))
          
      waitcnt(clkfreq / (rtime / 1500)+ cnt)
      

    repeat idx from 16 to 1          ' fro
      out32(idx)
      waitcnt(clkfreq / (rtime / 1500)+ cnt)
      

       term.tx(CLS)
       term.str(string("idx=   fro"))
       term.dec(idx)
       term.str(string("     ",CR))
      

         

PUB Load (BrightnessAt)

'' Call this routine with address of brighness variable.
'' The brighness variable should be set from 0-255, 0=full off, 255=full on.

'' BrightnessAt is address of variable to pass to PASM code to set the brighness (0 - 255)

        ZeroPin :=  |< CrossDetect  ' bit mask for Zero Crossing Detector Pin (Active High)
        OutputPin :=  |< Output     ' bit mask for Output Pin (Active High)

        BrightVarAt:=BrightnessAt             ' Push address of brighness into PASM code

        cognew(@Dimmer,@Stack)
        

PUB  death | idx, t, rtime, tmp

   repeat
     rtime := --rtime <# 0

       term.tx(CLS)
       term.str(string("rtime=  "))
       term.dec(rtime)
       term.str(string("     ",CR))
        't := cnt

        repeat idx from 1 to 16        ' to
          out32(idx)
           term.tx(CLS)
           term.str(string("idx= to"))
           term.dec(idx)
           term.str(string("     ",CR)) 
          waitcnt(clkfreq / (rtime / 1500)+ cnt)
      

      repeat idx from 16 to 1          ' fro
         out32(idx)
         waitcnt(clkfreq / (rtime / 1500)+ cnt)
         term.tx(CLS)
         term.str(string("idx=   fro"))
         term.dec(idx)
         term.str(string("     ",CR))
          t := cnt
    
      repeat tmp from 100 to 0
          level:=tmp                                 
          waitcnt(clkfreq/20 + cnt)

 volume := 0   
      

 
pub out32(n)

'' Enables one of 32 LEDs in matrix
'' -- output is 0 (off), 1 to 32 (led on)

  outa[LED_MSB..LED_LSB]~                                       ' clear to start
  dira[LED_MSB..LED_LSB]~~

  outa[COL_1..COL_0]~
  dira[COL_1..COL_0]~~

  if (n => 1) and (n =< 32)                                     ' if valid
    --n
    outa[LED_MSB..LED_LSB] := 1 << (n & %111)
    outa[COL_1..COL_0]     := 1 << (n >> 3)

pri playsound(pin, pntr, count) | rate, samples, addr, t        ' call with cognew

'' Plays 8-bit, mono audio file from DAT section
'' -- pin is pin for audio (uses CTRA)
'' -- pntr is start of audio
'' -- sampletm is sample timing in cnt ticks
'' -- count is number of plays before cog unloads itself

  if (count =< 0)                                               ' if 0, play "forever"
    count := posx

  rate    := clkfreq / long[pntr + 24]                          ' get rate from header
  samples := long[pntr + 40]                                    ' get samples from header

  frqa := $80 << 24                                             ' set to "0" 
  ctra := (%00110 << 26) + pin                                  ' duty cycle mode on pin
  dira[pin] := 1                                                ' make pin an output
  
  repeat count
    t := cnt
    addr := pntr + 44                                           ' skip over wav header
    repeat samples
      frqa := ((byte[addr++] - $80) * volume) << 16 + $8000_0000                                ' update dac, added volume control
      waitcnt(t += rate)
      
  ctra := 0
  cogstop(cogid)


pri stopsound

  if wavcog
    cogstop(wavcog~ - 1)

                          
DAT
{

Enter with the ADDRESS of the LONG that contains the brighness level.
The brightness level can be any value but it is looking for 0 = full off to 255 = full on.
If the value is less than 0, it is set to 0.
If the value is greater than 255, it is set to 255

}



                byte                                            ' force byte alignment
                
Cylon           file    "eye_11.wav"  
CylonEOF        byte    0                                       ' end of file

          
    org     0
                                                                                                
Dimmer
                mov     St1,OutputPin           ' Set all bits for input except output pin
                mov     dira, St1
:loop0          mov     outa,#0                 ' Clear output

:loop1          '' Look for leading edge of zero crossing input
                mov     st3,ina                 ' Read input value
                and     st3,ZeroPin wz          ' Mask off all but input bit
        if_z    jmp     #:loop1                 ' Bit not high, do it again


                rdlong  st1,BrightVarAt
                maxs    st1,#255
                mins    st1,#0

                mov     st3,#255                ' Invert because delay makes light dimmer
                sub     st3,st1

                '' See if full on, if so, skip delay
                cmp     st3,#0 wz
        if_z    jmp     #:loop2
        
                '' See if full off, if so, skip delay
                cmp     st3,#255 wz
        if_z    jmp     #:loop3
        
                '' Calculate number of clock cycles to delay for 0-255 level
                '' 100% on time = 80_000_000 / 120 = total of 666_667 clock cycles  (666_667/255 = 2614 counts/bit)
                '' Our full on = 2048+512+32+16=2608 clock cycles per level (2608*255=665_040 total clock cycles)
                  
                mov     st1,st3                 ' 80Mhz / (1/256 x 1/120) = 2604 clock cycles per half cycle 
                shl     st3,#11                 ' level x 2048 (2614 - 2048 = 566)

                mov     st2,st1                 
                shl     st2,#9                  ' level x 512 (566 - 512 = 54)
                add     st3,st2

                mov     st2,st1                 
                shl     st2,#5                  ' level x 32 (54 - 32 = 22) ' error of 22/2614 = insignificant but not 100% on
                add     st3,st2

                mov     st2,st1                 
                shl     st2,#4                  ' level x 16 (22 - 16 = 6) ' error of 6/2614 = insignificant but not 100% on
                add     st3,st2                 ' so if level = 255, skip timing and turn on immediately.

                add     st3,cnt                 ' Delay until this clock value is reached

                '' Check to see if main delay value is reached                
                waitcnt   st3,#0                ' Wait until main count time is reached, time to turn on Triac
:loop2
                mov     outa,OutputPin          ' Turn on output pin

:loop3          '' Look for trailing edge of zero crossing input
                mov     st3,ina                 ' Read input value
                and     st3,ZeroPin wz          ' Mask off all but input bit
        if_nz   jmp     #:loop3                 ' Bit high, do it again
                
:loop4          '' Look for leading edge of zero crossing input to go HIGH again to start next cycle
                mov     st3,ina                 ' Read input value
                and     st3,ZeroPin wz          ' Mask off all but input bit
        if_z    jmp     #:loop4                 ' Bit not high, loop until cycle ends

                '' Done with this half cycle, do it again
                mov     outa,#0
                jmp     #:loop0
                
              
ZeroPin         long    0                       ' Pin number for Zero-Crossing Pulse (Active High)
OutputPin       long    0                       ' Pin number for output to MOC3010M
BrightVarAt     long    0                       ' Address of brighness variable
     
ST1             res     1                       ' Temp 1
ST2             res     1                       ' Temp 2
ST3             res     1                       ' Temp 1

                fit     496         ' Make sure it fits within a cog's memory space